import { ReactNode } from "react";
export interface Datum {
    [key: string]: any;
}
export interface SortedFields {
    [propertyName: string]: "asc" | "desc";
}
interface Props {
    columns: {
        [propertyName: string]: string;
    };
    data: Datum[];
    sortedFields: SortedFields;
    selectable: boolean;
    sortable: boolean;
    noDataAvailableLabel: string;
    actionLabel: string;
    sortLabel: string;
    sortAscLabel: string;
    sortDescLabel: string;
    customRenderCell: (datum: Datum, propertyName: string) => ReactNode;
    renderAction: (datum: Datum) => ReactNode;
    onSelectedDataChange: (data: Datum[]) => void;
    onSortedFieldChange: (sortedFields: SortedFields) => void;
}
declare const DataTable: {
    (props: Props): JSX.Element;
    defaultProps: Partial<Props>;
};
export default DataTable;
