"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const react_bootstrap_1 = require("react-bootstrap");
const styled_components_1 = __importDefault(require("styled-components"));
const octicons_react_1 = require("@primer/octicons-react");
const TooltipContainer_1 = __importDefault(require("../tooltip/TooltipContainer"));
const RelativeTableHead = styled_components_1.default.th `
  position: relative;
`;
const RelativeTableData = styled_components_1.default.td `
  position: relative;
`;
const CheckboxContainer = styled_components_1.default.div `
  position: absolute;
  width: 15px;
  height: 15px;
  top: 0;
  right: 0;
  bottom: 0;
  left: 0;
  margin: auto;
`;
const Checkbox = styled_components_1.default.input.attrs(() => ({ type: "checkbox" })) `
  height: 100%;
  cursor: pointer;
`;
const HeaderCellContent = styled_components_1.default.a `
  position: relative;
  display: block;
  padding-right: 20px;
  line-height: 16px;
  cursor: pointer;
`;
const HeaderCellContentSort = styled_components_1.default.span `
  position: absolute;
  display: block;
  width: 16px;
  height: 16px;
  right: 0;
  bottom: 0;
`;
const DataTable = (props) => {
    const [sortedFields, setSortedFields] = react_1.useState(props.sortedFields);
    const [selectedData, setSelectedData] = react_1.useState([]);
    const selectAllData = react_1.useCallback((e) => setSelectedData(e.target.checked ? [...props.data] : []), [props.data]);
    const selectDatum = react_1.useCallback((e, datum) => {
        if (e.target.checked) {
            setSelectedData([...selectedData, datum]);
        }
        else {
            selectedData.splice(selectedData.findIndex(selectedDatum => selectedDatum === datum), 1);
            setSelectedData([...selectedData]);
        }
    }, [selectedData]);
    const sortField = react_1.useCallback((propertyName) => {
        if (props.sortable) {
            const order = sortedFields[propertyName];
            if (!order) {
                setSortedFields(Object.assign(Object.assign({}, sortedFields), { [propertyName]: "asc" }));
            }
            else if (order === "asc") {
                setSortedFields(Object.assign(Object.assign({}, sortedFields), { [propertyName]: "desc" }));
            }
            else if (order === "desc") {
                delete sortedFields[propertyName];
                setSortedFields(Object.assign({}, sortedFields));
            }
        }
    }, [props.sortable, sortedFields]);
    react_1.useEffect(() => {
        setSelectedData([]);
    }, [props.data]);
    react_1.useEffect(() => {
        props.onSelectedDataChange(selectedData);
    }, [selectedData]);
    react_1.useEffect(() => {
        props.onSortedFieldChange(sortedFields);
    }, [sortedFields]);
    react_1.useEffect(() => {
        setSortedFields(props.sortedFields);
    }, [props.sortedFields]);
    return (react_1.default.createElement("div", { className: "table-responsive" },
        react_1.default.createElement(react_bootstrap_1.Table, { striped: true, bordered: true, hover: true },
            react_1.default.createElement("thead", null,
                react_1.default.createElement("tr", null,
                    props.selectable && (react_1.default.createElement(RelativeTableHead, null,
                        react_1.default.createElement(CheckboxContainer, null,
                            react_1.default.createElement(Checkbox, { className: "form-control", checked: selectedData.length === props.data.length && selectedData.length > 0, onChange: selectAllData })))),
                    Object.keys(props.columns).map((propertyName, colIndex) => {
                        const order = sortedFields[propertyName];
                        return (react_1.default.createElement("th", { key: colIndex },
                            react_1.default.createElement(TooltipContainer_1.default, { enabled: props.sortable, message: !order ? props.sortLabel : order === "asc" ? props.sortAscLabel : props.sortDescLabel },
                                react_1.default.createElement(HeaderCellContent, { className: order ? "text-primary" : null, onClick: () => sortField(propertyName) },
                                    props.columns[propertyName],
                                    props.sortable && (react_1.default.createElement(HeaderCellContentSort, null, !order ? (react_1.default.createElement(octicons_react_1.UnfoldIcon, { className: "d-block", verticalAlign: "middle", size: 16 })) : order === "asc" ? (react_1.default.createElement(octicons_react_1.FoldDownIcon, { verticalAlign: "middle", size: 16 })) : (react_1.default.createElement(octicons_react_1.FoldUpIcon, { verticalAlign: "middle", size: 16 }))))))));
                    }),
                    props.renderAction && react_1.default.createElement("th", null, props.actionLabel))),
            react_1.default.createElement("tbody", null, props.data.map((datum, rowIndex) => (react_1.default.createElement("tr", { key: rowIndex },
                props.selectable && (react_1.default.createElement(RelativeTableData, null,
                    react_1.default.createElement(CheckboxContainer, null,
                        react_1.default.createElement(Checkbox, { className: "form-control", checked: selectedData.find(selectedDatum => selectedDatum === datum) != null, onChange: e => selectDatum(e, datum) })))),
                Object.keys(props.columns).map((propertyName, colIndex) => (react_1.default.createElement("td", { key: colIndex }, props.customRenderCell(datum, propertyName) || datum[propertyName]))),
                props.renderAction && react_1.default.createElement("td", null, props.renderAction(datum)))))),
            props.data.length === 0 && (react_1.default.createElement("tfoot", null,
                react_1.default.createElement("tr", null,
                    react_1.default.createElement("td", { className: "bg-light text-secondary text-center font-italic", colSpan: Object.keys(props.columns).length + (props.selectable ? 1 : 0) + (props.renderAction ? 1 : 0) }, props.noDataAvailableLabel)))))));
};
const defaultProps = {
    columns: {},
    data: [],
    sortedFields: {},
    selectable: false,
    sortable: false,
    noDataAvailableLabel: "No Data Available",
    actionLabel: "Action",
    sortLabel: "Sort Field",
    sortAscLabel: "Sort Ascending",
    sortDescLabel: "Sort Descending",
    customRenderCell: () => null,
    onSelectedDataChange: () => { },
    onSortedFieldChange: () => { },
};
DataTable.defaultProps = defaultProps;
exports.default = DataTable;
