import React, { ReactNode } from "react";
import { AxiosResponse } from "axios";
import { Datum, SortedFields } from "../DataTable";
import { Pagination as RemoteDataTablePagination } from "./util/Pagination";
import { Sorting as RemoteDateSorting } from "./util/Sorting";
export declare type Response = AxiosResponse;
interface Props {
    columns: {
        [propertyName: string]: string;
    };
    dataResourceHeaders: {
        [key: string]: string;
    };
    dataResourceUrl: string;
    dataPropertyPath: string;
    pagination: RemoteDataTablePagination;
    sorting: RemoteDateSorting;
    selectable: boolean;
    noDataAvailableLabel?: string;
    actionLabel: string;
    sortLabel: string;
    sortAscLabel: string;
    sortDescLabel: string;
    addNewFilterLabel: string;
    customRenderCell: (datum: Datum, propertyName: string) => ReactNode;
    renderAction: (datum: Datum) => ReactNode;
    interceptResponse: (response: Response) => Response;
    onPageChange: (page: number, size: number) => void;
    onSortedFieldsChange: (sortedFields: SortedFields) => void;
    onError: (error: Error) => void;
    onSelectedDataChange: (data: Datum[]) => void;
}
export interface RemoteDataTableRef {
    reload: () => void;
}
declare const RemoteDataTableWithRef: React.ForwardRefExoticComponent<Partial<Props> & React.RefAttributes<RemoteDataTableRef>>;
export default RemoteDataTableWithRef;
