"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const react_bootstrap_1 = require("react-bootstrap");
const styled_components_1 = __importDefault(require("styled-components"));
const axios_1 = __importDefault(require("axios"));
const Master_1 = require("../../master/Master");
const DataTable_1 = __importDefault(require("../DataTable"));
const Pagination_1 = require("./util/Pagination");
const Error_1 = require("../../util/Error");
const LoadingContainer = styled_components_1.default.div `
  background: rgba(0, 0, 0, 0.5);
`;
const RemoteDataTable = (props, ref) => {
    var _a, _b, _c, _d, _e, _f;
    const [data, setData] = react_1.useState([]);
    const [isLoading, setLoading] = react_1.useState(false);
    const [lastLoadedDataResourceUrl, setLastLoadedDataResourceUrl] = react_1.useState();
    const masterFactory = react_1.useContext(Master_1.MasterFactoryContext);
    const loadData = react_1.useCallback(() => __awaiter(void 0, void 0, void 0, function* () {
        var _g, _h;
        if (props.dataResourceUrl) {
            try {
                const dataResourceUrl = ((_g = props.sorting) === null || _g === void 0 ? void 0 : _g.sortingDataResourceUrl) || ((_h = props.pagination) === null || _h === void 0 ? void 0 : _h.paginatedDataResourceUrl) || props.dataResourceUrl;
                if (lastLoadedDataResourceUrl !== dataResourceUrl) {
                    setLoading(true);
                    const response = props.interceptResponse(yield axios_1.default.get(dataResourceUrl, { headers: props.dataResourceHeaders }));
                    if (response.data) {
                        let responseData = response.data;
                        if (props.dataPropertyPath) {
                            responseData = props.dataPropertyPath
                                .split(".")
                                .reduce((parent, propertyName) => parent[propertyName], responseData);
                        }
                        if (props.pagination) {
                            const page = props.pagination.pagePropertyPath
                                .split(".")
                                .reduce((parent, propertyName) => parent[propertyName], response.data);
                            const maxPage = props.pagination.maxPagePropertyPath
                                .split(".")
                                .reduce((parent, propertyName) => parent[propertyName], response.data);
                            if (page) {
                                props.pagination.setPage(page);
                            }
                            if (maxPage) {
                                props.pagination.setMaxPage(maxPage);
                            }
                        }
                        if (Array.isArray(responseData)) {
                            setData(responseData);
                            setLastLoadedDataResourceUrl(dataResourceUrl);
                        }
                        else {
                            Error_1.throwRemoteResponseError("dataPropertyPath", props.dataPropertyPath, responseData);
                        }
                    }
                }
            }
            catch (e) {
                props.onError(e);
            }
            setLoading(false);
        }
    }), [props.dataResourceHeaders, props.dataResourceUrl, props.pagination, props.sorting]);
    const onSortedFieldChange = react_1.useCallback((sortedFields) => {
        var _a;
        (_a = props.sorting) === null || _a === void 0 ? void 0 : _a.setSortedFields(sortedFields);
    }, []);
    react_1.useEffect(() => {
        var _a, _b, _c, _d, _e, _f, _g;
        (_a = props.pagination) === null || _a === void 0 ? void 0 : _a.setDataResourceUrl(props.dataResourceUrl);
        (_b = props.sorting) === null || _b === void 0 ? void 0 : _b.setDataResourceUrl(((_c = props.pagination) === null || _c === void 0 ? void 0 : _c.paginatedDataResourceUrl) || props.dataResourceUrl);
        if (!props.sorting ||
            !props.pagination ||
            (props.sorting && ((_d = props.sorting) === null || _d === void 0 ? void 0 : _d.sortingDataResourceUrl) &&
                ((_e = props.sorting) === null || _e === void 0 ? void 0 : _e.sortingDataResourceUrl) !== props.dataResourceUrl) ||
            (!props.sorting && ((_f = props.pagination) === null || _f === void 0 ? void 0 : _f.paginatedDataResourceUrl) &&
                ((_g = props.pagination) === null || _g === void 0 ? void 0 : _g.paginatedDataResourceUrl) !== props.dataResourceUrl)) {
            loadData();
        }
    }, [props.dataResourceUrl, (_a = props.pagination) === null || _a === void 0 ? void 0 : _a.paginatedDataResourceUrl, (_b = props.sorting) === null || _b === void 0 ? void 0 : _b.sortingDataResourceUrl]);
    react_1.useEffect(() => {
        if (props.pagination) {
            props.onPageChange(props.pagination.page, props.pagination.size);
        }
    }, [(_c = props.pagination) === null || _c === void 0 ? void 0 : _c.page, (_d = props.pagination) === null || _d === void 0 ? void 0 : _d.size]);
    react_1.useEffect(() => {
        if (props.sorting) {
            props.onSortedFieldsChange(props.sorting.sortedFields);
        }
    }, [(_e = props.sorting) === null || _e === void 0 ? void 0 : _e.sortedFields]);
    react_1.useEffect(() => {
        var _a;
        (_a = props.sorting) === null || _a === void 0 ? void 0 : _a.setMasterFactory(masterFactory);
    }, [masterFactory]);
    react_1.useImperativeHandle(ref, () => ({
        reload: () => loadData(),
    }));
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement("div", { className: "position-relative" },
            react_1.default.createElement(DataTable_1.default, { columns: props.columns, data: data, sortedFields: (_f = props.sorting) === null || _f === void 0 ? void 0 : _f.sortedFields, selectable: props.selectable, sortable: props.sorting != null, noDataAvailableLabel: props.noDataAvailableLabel, actionLabel: props.actionLabel, sortLabel: props.sortLabel, sortAscLabel: props.sortAscLabel, sortDescLabel: props.sortDescLabel, customRenderCell: props.customRenderCell, renderAction: props.renderAction, onSelectedDataChange: props.onSelectedDataChange, onSortedFieldChange: onSortedFieldChange }),
            isLoading && (react_1.default.createElement(LoadingContainer, { className: "position-absolute m-auto fixed-top fixed-bottom" },
                react_1.default.createElement(react_bootstrap_1.Spinner, { className: "position-absolute m-auto fixed-top fixed-bottom", animation: "border", variant: "light", role: "status" })))),
        react_1.default.createElement(Pagination_1.PaginationComponent, { className: "float-right", pagination: props.pagination, visible: data.length > 0 })));
};
const RemoteDataTableWithRef = react_1.forwardRef(RemoteDataTable);
const defaultProps = {
    interceptResponse: response => response,
    onPageChange: () => { },
    onSortedFieldsChange: () => { },
    onError: () => { },
};
RemoteDataTableWithRef.defaultProps = defaultProps;
exports.default = RemoteDataTableWithRef;
