/// <reference types="react" />
export interface Pagination {
    page: number;
    size: number;
    maxPage: number;
    pageQueryString: string;
    sizeQueryString: string;
    pagePropertyPath: string;
    maxPagePropertyPath: string;
    paginatedDataResourceUrl: string;
    isZeroPageBased: boolean;
    setPage: (page: number) => void;
    setMaxPage: (maxPage: number) => void;
    setDataResourceUrl: (dataResourceUrl: string) => void;
}
interface UsePaginationConfig {
    pagePropertyPath: string;
    maxPagePropertyPath: string;
    currentPage: number;
    size: number;
    isZeroPageBased: boolean;
    pageQueryString: string;
    sizeQueryString: string;
}
export declare const usePagination: (config?: Partial<UsePaginationConfig>) => Pagination;
interface Props {
    className: string;
    pagination: Pagination;
    visible: boolean;
}
export declare const PaginationComponent: (props: Partial<Props>) => JSX.Element;
export {};
