"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PaginationComponent = exports.usePagination = void 0;
const react_1 = __importStar(require("react"));
const react_bootstrap_1 = require("react-bootstrap");
const defaultPagePropertyPath = "";
const defaultMaxPagePropertyPath = "";
const defaultCurrentPage = 1;
const defaultSize = 1;
const defaultPageQueryString = "page";
const defaultSizeQueryString = "size";
exports.usePagination = (config = {}) => {
    let [page, setPage] = react_1.useState(config.currentPage || defaultCurrentPage);
    const [maxPage, setMaxPage] = react_1.useState(Number.MAX_SAFE_INTEGER);
    const [dataResourceUrl, setDataResourceUrl] = react_1.useState();
    if (page > maxPage) {
        page = maxPage;
    }
    else if (page < 1) {
        page = 1;
    }
    react_1.useEffect(() => {
        setPage(config.currentPage);
    }, [config.currentPage]);
    return {
        page,
        size: config.size || defaultSize,
        maxPage: maxPage === Number.MAX_SAFE_INTEGER ? 1 : maxPage,
        pageQueryString: config.pageQueryString || defaultPageQueryString,
        sizeQueryString: config.sizeQueryString || defaultSizeQueryString,
        pagePropertyPath: config.pagePropertyPath || defaultPagePropertyPath,
        maxPagePropertyPath: config.maxPagePropertyPath || defaultMaxPagePropertyPath,
        paginatedDataResourceUrl: dataResourceUrl
            ? `${dataResourceUrl}${dataResourceUrl.includes("?") ? "&" : "?"}${config.pageQueryString ||
                defaultPageQueryString}=${config.isZeroPageBased ? page - 1 : page}&${config.sizeQueryString ||
                defaultSizeQueryString}=${config.size || defaultSize}`
            : null,
        isZeroPageBased: config.isZeroPageBased ? true : false,
        setPage,
        setMaxPage,
        setDataResourceUrl,
    };
};
exports.PaginationComponent = (props) => props.pagination && props.visible ? (react_1.default.createElement(react_1.default.Fragment, null,
    react_1.default.createElement(react_bootstrap_1.Pagination, { className: props.className },
        react_1.default.createElement(react_bootstrap_1.Pagination.First, { onClick: () => props.pagination.setPage(1) }),
        react_1.default.createElement(react_bootstrap_1.Pagination.Prev, { onClick: () => props.pagination.setPage(props.pagination.page - 1) }),
        [...Array(props.pagination.maxPage)].map((_, index) => (react_1.default.createElement(react_bootstrap_1.Pagination.Item, { key: index, active: index + 1 === props.pagination.page, onClick: () => props.pagination.setPage(index + 1) }, index + 1))),
        react_1.default.createElement(react_bootstrap_1.Pagination.Next, { onClick: () => props.pagination.setPage(props.pagination.page + 1) }),
        react_1.default.createElement(react_bootstrap_1.Pagination.Last, { onClick: () => props.pagination.setPage(props.pagination.maxPage) })),
    react_1.default.createElement("div", { className: "clearfix" }))) : null;
