import React, { ReactNode } from "react";
import { Props as BaseFieldProps } from "./form/field/BaseField";
import { Response } from "../datatable/remote/RemoteDataTable";
import { Pagination } from "../datatable/remote/util/Pagination";
import { Sorting } from "../datatable/remote/util/Sorting";
import { Datum, SortedFields } from "../datatable/DataTable";
interface Props {
    title: string;
    children: ReactNode;
    dataFetchingResourceHeaders: {
        [key: string]: string;
    };
    dataFetchingResourceUrl: string;
    dataFetchingPropertyPath: string;
    dataFetchingPagination: Pagination;
    dataFetchingSorting: Sorting;
    interceptDataFetchingResponse: (response: Response) => Response;
    onDataFetchingPageChange: (page: number, size: number) => void;
    onDataFetchingSortedFieldsChange: (sortedFields: SortedFields) => void;
    onDataFetchingRequestError: (error: Error) => void;
    newInstanceFetchingResourceUrl: string;
    newInstanceFetchingMethod: "post" | "put" | "patch";
    onNewInstanceRequestError: (error: Error) => void;
    updateInstanceFetchingResourceUrl: string;
    updateInstanceFetchingMethod: "post" | "put" | "patch";
    onUpdateInstanceRequestError: (error: Error) => void;
    deleteInstanceFetchingResourceUrl: string;
    onDeleteInstanceRequestError: (error: Error) => void;
    loadingLabel: string;
    noDataAvailableLabel: string;
    actionLabel: string;
    sortLabel: string;
    sortAscLabel: string;
    sortDescLabel: string;
    addNewFilterLabel: string;
    saveButtonLabel: string;
    addNewButtonLabel: string;
    addNewFormTitle: string;
    updateFormTitle: string;
    deleteSelectedButtonLabel: string;
    deleteConfirmationTitle: string;
    deleteConfirmationMessage: {
        singular: string;
        plural: string;
    };
    deleteConfirmationYesLabel: string;
    deleteConfirmationNoLabel: string;
    successToAddMessage: string;
    successToUpdateMessage: string;
    successToDeleteMessage: string;
    customRenderAction: (datum: Datum) => ReactNode;
}
export interface MasterFactory {
    childrenProps?: BaseFieldProps[];
}
export declare const MasterFactoryContext: React.Context<MasterFactory>;
declare const Master: {
    (props: Props): JSX.Element;
    defaultProps: Partial<Props>;
};
export default Master;
