import React, { ReactNode } from "react";
import { Datum } from "../../datatable/DataTable";
export interface Fields {
    [propertyName: string]: {
        value: any;
        restValue: any;
    };
}
interface Props {
    datum: Datum;
    children: ReactNode;
    loadingLabel: string;
    saveButtonLabel: string;
    onSubmit: (restFields: Fields) => void;
}
declare class FormFactory {
    loadingLabel: string;
    private fields;
    private observers;
    private inboundRestParsers;
    private outboundRestParsers;
    private composeCustomRestValue;
    setRestParser<DataType>(propertyName: string, inboundRestParser: (value: any) => DataType, outboundRestParser: (value: DataType) => any): void;
    observe<DataType>(propertyName: string, observer: (value: DataType) => void): void;
    setField<DataType, RestPropertyNameType>(propertyName: string, restPropertyName: RestPropertyNameType, value: DataType): void;
    getField<DataType>(propertyName: string): DataType;
    getFields(): Fields;
    clearFields(): void;
    getRestFields(): Fields;
    getInboundRestParsers<DataType>(propertyName: any): (value: any) => DataType;
    getOutboundRestParsers<DataType>(propertyName: any): (value: DataType) => any;
}
export declare const FormFactoryContext: React.Context<FormFactory>;
declare const FormContainer: {
    (props: Props): JSX.Element;
    defaultProps: Partial<Props>;
};
export default FormContainer;
