import React, { ComponentType, ReactNode } from "react";
import { Datum } from "../../../datatable/DataTable";
export interface Props<DataType = any, RestPropertyNameType = string, InputPlaceholderDataType = string> {
    label: string;
    propertyName: string;
    restPropertyName: RestPropertyNameType;
    inputPlaceholder: InputPlaceholderDataType;
    inputAutoComplete: boolean;
    showOnDataTable: boolean;
    showOnForm: boolean;
    inputValidation: (value: DataType) => string;
    customRenderCell: (datum: Datum) => ReactNode;
    customInboundRestParser: (value: any) => DataType;
    customOutboundRestParser: (value: DataType) => any;
}
export interface TableCellProps<RestPropertyNameType = string> {
    datum: Datum;
    propertyName: string;
    restPropertyName?: RestPropertyNameType;
}
export interface InputFieldProps<DataType, RestPropertyNameType, InputPlaceholderDataType> extends Partial<Props<DataType, RestPropertyNameType, InputPlaceholderDataType>> {
    value?: DataType;
    onChange: (value: DataType) => void;
    isLoading: boolean;
    setLoading: (loading: boolean) => void;
}
export interface Field<DataType = string, AdditionalProps = {}, RestPropertyNameType = string, InputPlaceholderDataType = string> {
    (props: Partial<Props<DataType, RestPropertyNameType, InputPlaceholderDataType>> & AdditionalProps): JSX.Element;
    defaultProps?: Partial<Props<DataType, RestPropertyNameType, InputPlaceholderDataType>>;
    TableCellComponent?: ComponentType<TableCellProps<RestPropertyNameType> & Props<DataType, RestPropertyNameType, InputPlaceholderDataType> & AdditionalProps>;
}
export declare const createField: <DataType extends unknown = string, AdditionalProps extends {} = {}, RestPropertyNameType extends {} = string, InputPlaceholderDataType extends {} = string>(InputFieldComponent: React.ComponentType<InputFieldProps<DataType, RestPropertyNameType, InputPlaceholderDataType> & AdditionalProps>, TableCellComponent?: React.ComponentType<TableCellProps<RestPropertyNameType> & Props<DataType, RestPropertyNameType, InputPlaceholderDataType> & AdditionalProps>) => Field<DataType, AdditionalProps, RestPropertyNameType, InputPlaceholderDataType>;
declare const _default: {
    createField: <DataType extends unknown = string, AdditionalProps extends {} = {}, RestPropertyNameType extends {} = string, InputPlaceholderDataType extends {} = string>(InputFieldComponent: React.ComponentType<InputFieldProps<DataType, RestPropertyNameType, InputPlaceholderDataType> & AdditionalProps>, TableCellComponent?: React.ComponentType<TableCellProps<RestPropertyNameType> & Props<DataType, RestPropertyNameType, InputPlaceholderDataType> & AdditionalProps>) => Field<DataType, AdditionalProps, RestPropertyNameType, InputPlaceholderDataType>;
};
export default _default;
