"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createField = void 0;
const react_1 = __importStar(require("react"));
const react_bootstrap_1 = require("react-bootstrap");
const use_force_update_1 = __importDefault(require("use-force-update"));
const FormContainer_1 = require("../FormContainer");
exports.createField = (InputFieldComponent, TableCellComponent) => {
    const FieldComponent = props => {
        const [isLoading, setLoading] = react_1.useState(false);
        const formFactory = react_1.useContext(FormContainer_1.FormFactoryContext);
        const forceUpdate = use_force_update_1.default();
        const onChange = react_1.useCallback((value) => {
            formFactory === null || formFactory === void 0 ? void 0 : formFactory.setField(props.propertyName, props.restPropertyName || props.propertyName, value);
        }, []);
        const onValueUpdated = react_1.useCallback(() => forceUpdate(), []);
        formFactory === null || formFactory === void 0 ? void 0 : formFactory.setRestParser(props.propertyName, props.customInboundRestParser, props.customOutboundRestParser);
        formFactory === null || formFactory === void 0 ? void 0 : formFactory.observe(props.propertyName, onValueUpdated);
        if (props.showOnForm) {
            const inboundRestParser = formFactory === null || formFactory === void 0 ? void 0 : formFactory.getInboundRestParsers(props.propertyName);
            return (react_1.default.createElement(react_bootstrap_1.Form.Group, { controlId: props.propertyName },
                react_1.default.createElement(react_bootstrap_1.Form.Label, null, props.label),
                isLoading && (react_1.default.createElement("div", null,
                    react_1.default.createElement(react_bootstrap_1.Spinner, { className: "mr-2", animation: "border", variant: "primary", size: "sm", role: "status" }),
                    react_1.default.createElement("span", { className: "text-secondary" }, formFactory === null || formFactory === void 0 ? void 0 : formFactory.loadingLabel))),
                react_1.default.createElement(InputFieldComponent, Object.assign({}, props, { value: inboundRestParser
                        ? inboundRestParser(formFactory === null || formFactory === void 0 ? void 0 : formFactory.getField(props.propertyName))
                        : formFactory === null || formFactory === void 0 ? void 0 : formFactory.getField(props.propertyName), onChange: onChange, isLoading: isLoading, setLoading: setLoading }))));
        }
        return null;
    };
    FieldComponent.defaultProps = {
        showOnDataTable: true,
        showOnForm: true,
    };
    FieldComponent.TableCellComponent = TableCellComponent;
    return FieldComponent;
};
exports.default = { createField: exports.createField };
