"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createRemoteLabelValueCollectionField = void 0;
const react_1 = __importStar(require("react"));
const Remote_1 = require("../../../util/Remote");
const BaseField_1 = require("./BaseField");
exports.createRemoteLabelValueCollectionField = (InputFieldComponent, TableCellComponent) => BaseField_1.createField((_a) => {
    var { optionsResourceUrl, optionsPropertyPath, optionValuePropertyName, optionLabelPropertyName, interceptOptionsResourceResponse } = _a, props = __rest(_a, ["optionsResourceUrl", "optionsPropertyPath", "optionValuePropertyName", "optionLabelPropertyName", "interceptOptionsResourceResponse"]);
    const [options, setOptions] = react_1.useState();
    const loadDataFactory = Remote_1.useLoadData(props, optionsResourceUrl, "optionsPropertyPath", optionsPropertyPath);
    react_1.useEffect(() => {
        loadDataFactory.loadData().then(data => {
            if (interceptOptionsResourceResponse) {
                data = interceptOptionsResourceResponse(data);
            }
            setOptions(data === null || data === void 0 ? void 0 : data.map(datum => ({
                value: datum[optionValuePropertyName || "value"],
                label: datum[optionLabelPropertyName || "label"],
            })));
        });
    }, [
        optionsResourceUrl,
        optionsPropertyPath,
        optionValuePropertyName,
        optionLabelPropertyName,
        interceptOptionsResourceResponse,
    ]);
    return react_1.default.createElement(InputFieldComponent, Object.assign({}, props, { options: options }));
}, (_a) => {
    var { optionsResourceUrl, optionsPropertyPath, optionValuePropertyName, optionLabelPropertyName, interceptOptionsResourceResponse } = _a, props = __rest(_a, ["optionsResourceUrl", "optionsPropertyPath", "optionValuePropertyName", "optionLabelPropertyName", "interceptOptionsResourceResponse"]);
    const [options, setOptions] = react_1.useState();
    const loadDataFactory = Remote_1.useLoadData(null, optionsResourceUrl, "optionsPropertyPath", optionsPropertyPath);
    react_1.useEffect(() => {
        loadDataFactory.loadData().then(data => {
            if (interceptOptionsResourceResponse) {
                data = interceptOptionsResourceResponse(data);
            }
            setOptions(data === null || data === void 0 ? void 0 : data.map(datum => ({
                value: datum[optionValuePropertyName || "value"],
                label: datum[optionLabelPropertyName || "label"],
            })));
        });
    }, [
        optionsResourceUrl,
        optionsPropertyPath,
        optionValuePropertyName,
        optionLabelPropertyName,
        interceptOptionsResourceResponse,
    ]);
    return react_1.default.createElement(TableCellComponent, Object.assign({}, props, { options: options }));
});
