"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const react_datepicker_1 = __importDefault(require("react-datepicker"));
const react_bootstrap_1 = require("react-bootstrap");
const date_fns_1 = require("date-fns");
const BaseField_1 = require("./BaseField");
const DateField = BaseField_1.createField(props => {
    return (react_1.default.createElement(react_datepicker_1.default, { wrapperClassName: "d-block", customInput: react_1.default.createElement(react_bootstrap_1.Form.Control, { type: "text" }), autoComplete: "off", dateFormat: props.format || "dd MMM yyyy", placeholderText: props.inputPlaceholder, selected: !props.value || typeof props.value !== "string"
            ? props.value
            : props.parseFormat
                ? date_fns_1.parse(props.value, props.parseFormat, null)
                : date_fns_1.parseJSON(props.value), onChange: props.onChange, onChangeRaw: e => e.preventDefault() }));
}, props => {
    const value = props.datum[props.restPropertyName || props.propertyName];
    return (react_1.default.createElement(react_1.default.Fragment, null, date_fns_1.format(props.parseFormat ? date_fns_1.parse(value, props.parseFormat, null) : date_fns_1.parseJSON(value), props.format || "dd MMM yyyy")));
});
exports.default = DateField;
