"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const react_bootstrap_1 = require("react-bootstrap");
const styled_components_1 = __importDefault(require("styled-components"));
const classnames_1 = __importDefault(require("classnames"));
const octicons_react_1 = require("@primer/octicons-react");
const BaseField_1 = require("./BaseField");
const ImageThumbnailMask = styled_components_1.default.div `
  width: ${(props) => props.width}px;
  height: ${(props) => props.height}px;
  overflow: hidden;
  position: relative;
  border-radius: 8px;
  img {
    position: absolute;
    right: -100%;
    left: -100%;
    margin: auto;
    opacity: 0;
    transition: opacity 0.2s;
  }
  &.loaded {
    img {
      opacity: 1;
    }
  }
  &.portrait {
    img {
      width: 100%;
      height: auto;
    }
  }
  &.landscape {
    img {
      width: auto;
      height: 100%;
    }
  }
`;
const ImagePickerContainer = styled_components_1.default.label `
  display: inline-block;
  cursor: pointer;
  position: relative;
  input[type="file"] {
    display: none;
  }
  span {
    position: absolute;
    color: white;
    bottom: 0;
    right: 0;
    left: 0;
    margin: auto;
    line-height: 16px;
    padding: 8px;
    text-align: center;
    background: #007bff;
    border-radius: 0 0 8px 8px;
    transition: opacity 0.4s;
    svg {
      margin-right: 4px;
    }
  }
  :hover {
    span {
      opacity: 0.8;
    }
  }
`;
const ImageThumbnail = (props) => {
    const [direction, setDirection] = react_1.useState();
    const image = react_1.useRef();
    const onImageLoad = react_1.useCallback(() => {
        const { width, height } = image.current;
        if (width <= height) {
            setDirection("portrait");
        }
        else {
            setDirection("landscape");
        }
    }, [image]);
    return (react_1.default.createElement(ImageThumbnailMask, { className: classnames_1.default({
            loaded: direction != null,
            portrait: direction === "portrait",
            landscape: direction === "landscape",
        }), width: props.width, height: props.height },
        react_1.default.createElement("img", { ref: image, src: props.src, onLoad: onImageLoad })));
};
const ImagePicker = (props) => {
    const onChange = react_1.useCallback((e) => {
        const reader = new FileReader();
        reader.readAsDataURL(e.target.files[0]);
        reader.onload = () => {
            props.onChange(reader.result.toString());
        };
    }, []);
    return (react_1.default.createElement("div", null,
        react_1.default.createElement(ImagePickerContainer, null,
            react_1.default.createElement(ImageThumbnail, { src: props.src, width: props.width, height: props.height }),
            react_1.default.createElement(react_bootstrap_1.Form.Control, { type: "file", accept: "image/*", onChange: onChange }),
            react_1.default.createElement("span", null,
                react_1.default.createElement(octicons_react_1.DeviceCameraIcon, { verticalAlign: "top" }),
                props.command))));
};
const defaultProps = {
    command: "Edit",
    onChange: () => { },
};
ImagePicker.defaultProps = defaultProps;
const ImageField = BaseField_1.createField(props => (react_1.default.createElement(ImagePicker, { src: props.value, width: 125, height: 125, command: props.command, onChange: base64 => props.onChange(base64) })), props => react_1.default.createElement(ImageThumbnail, { src: props.datum[props.restPropertyName || props.propertyName], width: 80, height: 80 }));
exports.default = ImageField;
