"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const react_bootstrap_1 = require("react-bootstrap");
const BaseField_1 = require("./BaseField");
const TextField = BaseField_1.createField(props => {
    const onChange = react_1.useCallback((e) => props.onChange(props.type === "tel" ? e.target.value.replace(/\D/, "") : e.target.value), [props.type]);
    return (react_1.default.createElement(react_bootstrap_1.Form.Control, { type: props.type || "text", autoComplete: props.inputAutoComplete ? "on" : "off", placeholder: props.inputPlaceholder, value: props.value, onChange: onChange }));
}, ({ type, datum, restPropertyName, propertyName }) => {
    const value = datum[restPropertyName || propertyName];
    if (value) {
        if (type === "email") {
            return react_1.default.createElement("a", { href: `mailto:${value}` }, value);
        }
        else if (type === "password") {
            return "********";
        }
        else if (type === "tel") {
            return react_1.default.createElement("a", { href: `tel:${value}` }, value);
        }
        else if (type === "url") {
            return (react_1.default.createElement("a", { href: value.startsWith("http://") || value.startsWith("https://") || value.startsWith("//")
                    ? value
                    : `//${value.toLowerCase()}` }, value));
        }
    }
    return value;
});
exports.default = TextField;
