"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const react_bootstrap_1 = require("react-bootstrap");
const octicons_react_1 = require("@primer/octicons-react");
const Header = (props) => {
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(react_bootstrap_1.Row, { className: "mt-3" },
            react_1.default.createElement(react_bootstrap_1.Col, { xs: 7, md: 9, lg: 7 },
                react_1.default.createElement("h1", null, props.title)),
            react_1.default.createElement(react_bootstrap_1.Col, { xs: 5, md: 3, lg: 5 },
                react_1.default.createElement(react_bootstrap_1.Row, { className: "mt-2", noGutters: true },
                    react_1.default.createElement(react_bootstrap_1.Col, { className: "pr-1 pr-lg-2", xs: 6, lg: 6 }, props.showDeleteSelectedButton && (react_1.default.createElement(react_bootstrap_1.Button, { variant: "outline-danger", block: true, onClick: props.onDeleteSelectedButtonClick },
                        react_1.default.createElement(octicons_react_1.TrashcanIcon, { verticalAlign: "middle", size: 16 }),
                        " ",
                        react_1.default.createElement("span", { className: "d-none d-lg-inline" }, props.deleteSelectedButtonLabel)))),
                    react_1.default.createElement(react_bootstrap_1.Col, { className: "pl-1 pl-lg-2", xs: 6, lg: 6 },
                        react_1.default.createElement(react_bootstrap_1.Button, { variant: "primary", block: true, onClick: props.onAddNewButtonClick },
                            react_1.default.createElement(octicons_react_1.PlusIcon, { verticalAlign: "middle", size: 16 }),
                            " ",
                            react_1.default.createElement("span", { className: "d-none d-lg-inline" }, props.addNewButtonLabel)))))),
        react_1.default.createElement("hr", null)));
};
const defaultProps = {
    addNewButtonLabel: "Add New",
    deleteSelectedButtonLabel: "Delete Selected",
    onDeleteSelectedButtonClick: () => { },
    onAddNewButtonClick: () => { },
};
Header.defaultProps = defaultProps;
exports.default = Header;
