"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const react_bootstrap_1 = require("react-bootstrap");
const ModalContainer = (props, ref) => {
    const [isVisible, setVisible] = react_1.useState();
    const onHide = react_1.useCallback(() => setVisible(false), []);
    react_1.useImperativeHandle(ref, () => ({
        show: () => setVisible(true),
        hide: () => setVisible(false),
    }));
    react_1.useEffect(() => {
        if (isVisible === false) {
            props.onHide();
        }
    }, [isVisible]);
    return (react_1.default.createElement(react_bootstrap_1.Modal, { size: props.size, show: isVisible, animation: true, onHide: onHide },
        react_1.default.createElement(react_bootstrap_1.Modal.Header, { closeButton: true },
            react_1.default.createElement(react_bootstrap_1.Modal.Title, null, props.title)),
        react_1.default.createElement(react_bootstrap_1.Modal.Body, null, props.children)));
};
const ModalContainerWithRef = react_1.forwardRef(ModalContainer);
const defaultProps = {
    size: "sm",
    onHide: () => { },
};
ModalContainerWithRef.defaultProps = defaultProps;
exports.default = ModalContainerWithRef;
