"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const react_bootstrap_1 = require("react-bootstrap");
const styled_components_1 = __importDefault(require("styled-components"));
const octicons_react_1 = require("@primer/octicons-react");
const TagContainer = styled_components_1.default.a `
  display: inline-block;
  cursor: pointer;
  margin-right: 0.5rem;
  :last-child {
    margin-right: 0;
  }
`;
const TagContent = styled_components_1.default.span `
  font-size: 14px;
`;
const Operator = styled_components_1.default.span `
  color: #ffd70d;
`;
const Tag = (props) => (react_1.default.createElement(TagContainer, null,
    react_1.default.createElement(react_bootstrap_1.Badge, { variant: "primary" },
        react_1.default.createElement(TagContent, null,
            props.content,
            props.operator && react_1.default.createElement(Operator, { className: "ml-1" }, props.operator),
            props.subContent && (react_1.default.createElement(react_1.default.Fragment, null,
                react_1.default.createElement(react_bootstrap_1.Badge, { className: "ml-1", variant: "light" },
                    react_1.default.createElement(TagContent, null, props.subContent))))),
        react_1.default.createElement(octicons_react_1.XCircleFillIcon, { className: "ml-1 text-light", verticalAlign: "middle", size: 16 }))));
exports.default = Tag;
